9abf8c
From 0954a69e884e99af5082f93e2de30fa8dfdba83e Mon Sep 17 00:00:00 2001
9abf8c
From: Hannes Reinecke <hare@suse.com>
9abf8c
Date: Mon, 25 Nov 2019 11:33:42 +0100
9abf8c
Subject: [PATCH] 95nvmf: add module for NVMe-oF
9abf8c
9abf8c
Add a module for booting from NVMe-oF devices.
9abf8c
9abf8c
Signed-off-by: Hannes Reinecke <hare@suse.de>
9abf8c
(cherry picked from commit 2f03d69f9dfdc0c905c4d9cb69ee93a5256123cb)
9abf8c
9abf8c
Resolves: #1731601
9abf8c
---
9abf8c
 dracut.spec                                     |  1 +
9abf8c
 modules.d/95nvmf/module-setup.sh                | 88 +++++++++++++++++++++++
9abf8c
 modules.d/95nvmf/parse-nvmf-boot-connections.sh | 95 +++++++++++++++++++++++++
9abf8c
 3 files changed, 184 insertions(+)
9abf8c
9abf8c
diff --git a/dracut.spec b/dracut.spec
9abf8c
index a8076c18..3db5c0cf 100644
9abf8c
--- a/dracut.spec
9abf8c
+++ b/dracut.spec
9abf8c
@@ -370,6 +370,7 @@ install -m 0755 51-dracut-rescue-postinst.sh $RPM_BUILD_ROOT%{_sysconfdir}/kerne
9abf8c
 %{dracutlibdir}/modules.d/95debug
9abf8c
 %{dracutlibdir}/modules.d/95fstab-sys
9abf8c
 %{dracutlibdir}/modules.d/95lunmask
9abf8c
+%{dracutlibdir}/modules.d/95nvmf
9abf8c
 %{dracutlibdir}/modules.d/95resume
9abf8c
 %{dracutlibdir}/modules.d/95rootfs-block
9abf8c
 %{dracutlibdir}/modules.d/95terminfo
9abf8c
diff --git a/modules.d/95nvmf/module-setup.sh b/modules.d/95nvmf/module-setup.sh
9abf8c
new file mode 100755
9abf8c
index 00000000..db43ec01
9abf8c
--- /dev/null
9abf8c
+++ b/modules.d/95nvmf/module-setup.sh
9abf8c
@@ -0,0 +1,88 @@
9abf8c
+#!/bin/bash
9abf8c
+
9abf8c
+# called by dracut
9abf8c
+check() {
9abf8c
+    require_binaries nvme || return 1
9abf8c
+    [ -f /etc/nvme/hostnqn ] || return 255
9abf8c
+    [ -f /etc/nvme/hostid ] || return 255
9abf8c
+
9abf8c
+    is_nvme_fc() {
9abf8c
+        local _dev=$1
9abf8c
+        local traddr
9abf8c
+
9abf8c
+        [[ -L "/sys/dev/block/$_dev" ]] || return 0
9abf8c
+        cd -P "/sys/dev/block/$_dev" || return 0
9abf8c
+        if [ -f partition ] ; then
9abf8c
+            cd ..
9abf8c
+        fi
9abf8c
+        for d in device/nvme* ; do
9abf8c
+            [ -L "$d" ] || continue
9abf8c
+            if readlink "$d" | grep -q nvme-fabrics ; then
9abf8c
+                traddr=$(cat "$d"/address)
9abf8c
+		break
9abf8c
+	    fi
9abf8c
+	done
9abf8c
+        [[ "${traddr#traddr=nn-}" != "$traddr" ]]
9abf8c
+    }
9abf8c
+
9abf8c
+    [[ $hostonly ]] || [[ $mount_needs ]] && {
9abf8c
+        pushd . >/dev/null
9abf8c
+        for_each_host_dev_and_slaves is_nvme_fc
9abf8c
+        local _is_nvme_fc=$?
9abf8c
+        popd >/dev/null
9abf8c
+        [[ $_is_nvme_fc == 0 ]] || return 255
9abf8c
+        if [ ! -f /sys/class/fc/fc_udev_device/nvme_discovery ] ; then
9abf8c
+            if [ ! -f /etc/nvme/discovery.conf ] ; then
9abf8c
+                echo "No discovery arguments present"
9abf8c
+                return 255
9abf8c
+            fi
9abf8c
+        fi
9abf8c
+    }
9abf8c
+    return 0
9abf8c
+}
9abf8c
+
9abf8c
+# called by dracut
9abf8c
+depends() {
9abf8c
+    echo bash rootfs-block
9abf8c
+    return 0
9abf8c
+}
9abf8c
+
9abf8c
+# called by dracut
9abf8c
+installkernel() {
9abf8c
+    instmods nvme_fc lpfc qla2xxx
9abf8c
+}
9abf8c
+
9abf8c
+# called by dracut
9abf8c
+cmdline() {
9abf8c
+    local _hostnqn
9abf8c
+    local _hostid
9abf8c
+    if [ -f /etc/nvme/hostnqn ] ; then
9abf8c
+        _hostnqn=$(cat /etc/nvme/hostnqn)
9abf8c
+        echo -n " nvmf.hostnqn=${_hostnqn}"
9abf8c
+    fi
9abf8c
+    if [ -f /etc/nvme/hostid ] ; then
9abf8c
+        _hostid=$(cat /etc/nvme/hostid)
9abf8c
+        echo -n " nvmf.hostid=${_hostid}"
9abf8c
+    fi
9abf8c
+    echo ""
9abf8c
+}
9abf8c
+
9abf8c
+# called by dracut
9abf8c
+install() {
9abf8c
+    if [[ $hostonly_cmdline == "yes" ]]; then
9abf8c
+	local _nvmf_args=$(cmdline)
9abf8c
+	[[ "$_nvmf_args" ]] && printf "%s" "$_nvmf_args" >> "${initdir}/etc/cmdline.d/95nvmf-args.conf"
9abf8c
+    fi
9abf8c
+    inst_simple "/etc/nvme/hostnqn"
9abf8c
+    inst_simple "/etc/nvme/hostid"
9abf8c
+
9abf8c
+    inst_multiple nvme
9abf8c
+    inst_multiple -o \
9abf8c
+        "$systemdsystemunitdir/nvm*-connect@.service" \
9abf8c
+        "$systemdsystemunitdir/nvm*-connect.target"
9abf8c
+    inst_hook cmdline 99 "$moddir/parse-nvmf-boot-connections.sh"
9abf8c
+    inst_simple "/etc/nvme/discovery.conf"
9abf8c
+    inst_rules /usr/lib/udev/rules.d/70-nvm*-autoconnect.rules
9abf8c
+    inst_rules /usr/lib/udev/rules.d/71-nvmf-iopolicy-netapp.rules
9abf8c
+    dracut_need_initqueue
9abf8c
+}
9abf8c
diff --git a/modules.d/95nvmf/parse-nvmf-boot-connections.sh b/modules.d/95nvmf/parse-nvmf-boot-connections.sh
9abf8c
new file mode 100755
9abf8c
index 00000000..0d16b871
9abf8c
--- /dev/null
9abf8c
+++ b/modules.d/95nvmf/parse-nvmf-boot-connections.sh
9abf8c
@@ -0,0 +1,95 @@
9abf8c
+#!/bin/sh
9abf8c
+#
9abf8c
+# Supported formats:
9abf8c
+# nvmf.hostnqn=<hostnqn>
9abf8c
+# nvmf.hostid=<hostid>
9abf8c
+# nvmf.discover=<transport>:<traddr>:<host-traddr>:<trsvcid>
9abf8c
+#
9abf8c
+# Examples:
9abf8c
+# nvmf.hostnqn=nqn.2014-08.org.nvmexpress:uuid:37303738-3034-584d-5137-333230423843
9abf8c
+# nvmf.discover=rdma:192.168.1.3::4420
9abf8c
+# nvmf.discover=fc:auto
9abf8c
+#
9abf8c
+# Note: FC does autodiscovery, so typically there is no need to
9abf8c
+# specify any discover parameters for FC.
9abf8c
+#
9abf8c
+
9abf8c
+parse_nvmf_discover() {
9abf8c
+    OLDIFS="$IFS"
9abf8c
+    IFS=:
9abf8c
+    trtype="none"
9abf8c
+    traddr="none"
9abf8c
+    hosttraddr="none"
9abf8c
+    trsvcid=4420
9abf8c
+
9abf8c
+    set $1
9abf8c
+    IFS="$OLDIFS"
9abf8c
+
9abf8c
+    case $# in
9abf8c
+        2)
9abf8c
+            trtype=$1
9abf8c
+            traddr=$2
9abf8c
+            ;;
9abf8c
+        3)
9abf8c
+            trtype=$1
9abf8c
+            traddr=$2
9abf8c
+            hosttraddr=$3
9abf8c
+            ;;
9abf8c
+        4)
9abf8c
+            trtype=$1
9abf8c
+            traddr=$2
9abf8c
+            hosttraddr=$3
9abf8c
+            trsvcid=$4
9abf8c
+            ;;
9abf8c
+        *)
9abf8c
+            warn "Invalid arguments for nvmf.discover=$1"
9abf8c
+            return 1
9abf8c
+            ;;
9abf8c
+    esac
9abf8c
+    if [ -z "$traddr" ] ; then
9abf8c
+        warn "traddr is mandatory for $trtype"
9abf8c
+        return 1;
9abf8c
+    fi
9abf8c
+    [ -z "$hosttraddr" ] && hosttraddr="none"
9abf8c
+    [ -z "$trsvcid" ] && trsvcid="none"
9abf8c
+    if [ "$trtype" = "fc" ] ; then
9abf8c
+        if [ -z "$hosttraddr" ] ; then
9abf8c
+            warn "host traddr is mandatory for fc"
9abf8c
+            return 1
9abf8c
+        fi
9abf8c
+    elif [ "$trtype" != "rdma" ] && [ "$trtype" != "tcp" ] ; then
9abf8c
+        warn "unsupported transport $trtype"
9abf8c
+        return 1
9abf8c
+    elif [ -z "$trsvcid" ] ; then
9abf8c
+        trsvcid=4420
9abf8c
+    fi
9abf8c
+    echo "--transport=$trtype --traddr=$traddr --host-traddr=$hosttraddr --trsvcid=$trsvcid" >> /etc/nvme/discovery.conf
9abf8c
+}
9abf8c
+
9abf8c
+if ! getargbool 0 rd.nonvmf ; then
9abf8c
+	info "rd.nonvmf=0: skipping nvmf"
9abf8c
+	return 0
9abf8c
+fi
9abf8c
+
9abf8c
+nvmf_hostnqn=$(getarg nvmf.hostnqn=)
9abf8c
+if [ -n "$nvmf_hostnqn" ] ; then
9abf8c
+    echo "$nvmf_hostnqn" > /etc/nvme/hostnqn
9abf8c
+fi
9abf8c
+nvmf_hostid=$(getarg nvmf.hostid=)
9abf8c
+if [ -n "$nvmf_hostid" ] ; then
9abf8c
+    echo "$nvmf_hostid" > /etc/nvme/hostid
9abf8c
+fi
9abf8c
+
9abf8c
+for d in $(getargs nvmf.discover=); do
9abf8c
+    parse_nvmf_discover "$d"
9abf8c
+done
9abf8c
+
9abf8c
+# Host NQN and host id are mandatory for NVMe-oF
9abf8c
+[ -f "/etc/nvme/hostnqn" ] || exit 0
9abf8c
+[ -f "/etc/nvme/hostid" ] || exit 0
9abf8c
+
9abf8c
+if [ -f "/etc/nvme/discovery.conf" ] ; then
9abf8c
+    /sbin/initqueue --onetime --unique --name nvme-discover /usr/sbin/nvme connect-all
9abf8c
+else
9abf8c
+    /sbin/initqueue --finished --unique --name nvme-fc-autoconnect echo 1 > /sys/class/fc/fc_udev_device/nvme_discovery
9abf8c
+fi
9abf8c